#include <tiuser.h>
#include <stropts.h>
#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

extern int t_errno;

#define SERV_PORT 5134

main()
{
   int dg_fd;           /* file descriptor into transport */
   struct t_bind *req;  /* requested addr to which to bind*/
   struct t_bind *ret;  /* actual address that was bound  */
   int flags;           /* holds info when reading        */
   struct t_unitdata *datap;  /* the actual datagram      */
   struct sockaddr_in myaddr; /* address of server        */

   char cmd[BUFSIZ];     /* used to figure out if the     */
   char junkbuf[BUFSIZ]; /* specified user is logged      */
   FILE *fp;             /* onto the system               */

   if ((dg_fd = t_open("/dev/udp", O_RDWR, NULL)) < 0) {
      t_error("t_open failed");
      exit(1);
   }

   /*
    *  Get space to hold the address to which you want
    *  to bind.
    */

   if ((req = (struct t_bind *)t_alloc(dg_fd, T_BIND,
                                         T_ALL)) == NULL) {
      t_error("t_alloc failed");
      exit(1);
   }

   /*
    *  Get space to hold the address to which you
    *  actually bind.
    */

   if ((ret = (struct t_bind *)t_alloc(dg_fd, T_BIND,
                                        T_ALL)) == NULL) {
      t_error("t_alloc failed");
      exit(1);
   }

   /*
    *  Set qlen to 0 because qlen has no meaning for
    *  connectionless transport providers.
    */

   req->qlen = 0;
   req->addr.len = sizeof(struct sockaddr_in);

   memset((void *)&myaddr, 0, sizeof(struct sockaddr_in));
   myaddr.sin_family = AF_INET;
   myaddr.sin_port = htons(SERV_PORT);
   myaddr.sin_addr.s_addr = htonl(INADDR_ANY);

   (void)memcpy(req->addr.buf, &myaddr,
                                 sizeof(struct sockaddr_in));

   /*
    *  Bind to the address the service will be offered
    *  over.
    */

   if (t_bind(dg_fd, req, ret) < 0) {
      t_error("t_bind failed");
      exit(1);
   }

   /*
    *  Make sure the address you got was the one you wanted!
    */

   if ((req->addr.len != ret->addr.len) ||
     (memcmp(req->addr.buf, ret->addr.buf, req->addr.len))){
      fprintf(stderr, "Did not bind to correct address!\n");
      exit(1);
   }
   if ((datap = (struct t_unitdata *)t_alloc(dg_fd,
                              T_UNITDATA, T_ALL)) == NULL) {
      t_error("could not allocate space for t_unitdata!");
      exit(1);
   }

   /*
    *  Loop continuously, processing datagrams.
    */

   while (1) {
      if (t_rcvudata(dg_fd, datap, &flags) < 0) {
         /*
          *  If the t_rcvudata() routine fails, check if the
          *  reason was because an error occurred on a
          *  previous datagram we sent (t_errno is set to
          *  TLOOK if that is the case).  If that's so,
          *  clear the error event with t_rcvuderr().
          */
         if (t_errno == TLOOK) {
            if (t_rcvuderr(dg_fd, NULL) < 0) {
               t_error("could not clear error event!");
            }
         } else {
            t_error("could not read datagram!");
         }
         continue;
      }

      sprintf(cmd, "who | grep '^%s '", datap->udata.buf);
      if ((fp = popen(cmd, "r")) == NULL
       || fgets(junkbuf, BUFSIZ, fp) == NULL) {
         strcpy(datap->udata.buf, "n");
      } else {
         strcpy(datap->udata.buf, "y");
      }
      datap->udata.len = 1;
      if (t_sndudata(dg_fd, datap) < 0) {
         t_error("could not send datagram!");
         continue;
      }
   }
}
